unit Unit2;

interface
uses sysutils,dialogs;
  type cha=record
   i,k:byte;
   t,n,dtb,pita:integer;
   tmr,pau:integer;
  end;
  onenote=record
   instr:byte;
   ton,n,dtb:integer;
  end;
  patt=^pattern;

  pattern=record
   d:array[0..1200]of onenote;
   c,np:integer;
   next:patt;
  end;

  sound=record
   trb,dtb:integer;
   dtn,ton,tmr,pau:integer;
  end;

  type instro=record
   onit:boolean;
   kln,cpf,mpf,klt:integer;
   snd:array[0..15]of sound;
  end;
  type namei=string[40];


var
  cby,counby,vseby,curp,maxp,preb:integer;
  pitch,polt:array[0..15]of real;
  all:array[0..15]of cha;
  clot,dive,plen,ppos,posall,gg,tra,start:integer;
  toe:textfile;
  tr:array[0..15]of patt;
  plist:patt;
  uplist:array[0..15,0..1500]of patt;
  nttb:array[0..11]of double;
  octv:array[-2..9]of double;
  dada:integer;
  db,dw:string;
  ext,fush:boolean;
  md,sdvig:integer;
    instros:array[0..255]of instro;
    usedes:array[0..255]of byte;
  procedure startz;
  procedure endz;
  procedure wriz;
implementation

procedure addbi(n:integer);
begin
 if counby>=vseby then exit;
 counby:=counby+n;
 if (counby>=vseby)and fush then
 begin
  maxp:=preb;
  //if n=32 then dec(maxp);
  ext:=true;
  //showmessage(inttostr(curp));
 end
end;

procedure startz;
var i,j:integer;
begin
 curp:=-1;
 maxp:=-1;
 counby:=32;
 gg:=0;
 for i:=0 to 15 do
 begin
  new(tr[i]);
  for j:=0 to posall+1 do uplist[i,j]:=nil;
 end;
 assignfile(toe,'music.asm');
 rewrite(toe);
 posall:=0;
 plist:=nil;
end;

function comparepatt(aa,bb:patt):boolean;
var u:integer;
d:boolean;
begin
 d:=true;
 for u:=0 to plen-1 do
 if aa^.d[u].ton<>bb^.d[u].ton then d:=false;
 result:=d;
end;

function copysav(p:patt):patt;
var i:integer;
lu:patt;
begin
 new(lu);
 for i:=0 to plen-1 do
 begin
  lu^.d[i].ton:=p^.d[i].ton;
  lu^.d[i].n:=p^.d[i].n;
  lu^.d[i].dtb:=p^.d[i].dtb;
 end;
 result:=lu;
end;

function savepatt(p:patt):patt;
var m,oi:patt;
begin
 m:=plist;
 while m<>nil do
 begin
  if comparepatt(m,p) then
  begin
   result:=m;
   exit;
  end;
  m:=m^.next;
 end;
 m:=copysav(p);
 m^.np:=posall;
 if m^.np>=dada then ext:=true;
 if plist=nil then
 begin
  m^.next:=nil;
  m^.c:=0;
  plist:=m;
 end else
 begin
  oi:=plist;
  while oi^.next<>nil do oi:=oi^.next;
  m^.next:=nil;
  oi^.next:=m;
  m.c:=oi.c+1;
 end;
 result:=m;
end;

procedure printp(p:patt);
var i,h:integer;
tn,d:integer;
begin
 if p^.np>curp then
 begin
  addbi(32*(p^.np-curp));
  preb:=curp;
  curp:=p^.np;
 end;
 writeln(toe,'fpat'+inttostr(p^.c)+':;'+inttostr(p^.np));
 i:=0;
 repeat
  tn:=p^.d[i].ton;
  d:=p^.d[i].dtb;
  h:=0;
  repeat
   inc(i);
   inc(h);
  until (i=plen)or(tn<>p^.d[i].ton);
  writeln(toe,'   '+db+' '+inttostr(tn mod 256)+','+inttostr((tn mod 65536)div 256)+','+inttostr(tn div 65536)+','+inttostr(d)+','+inttostr(h)+','+inttostr(p^.d[i-1].n));
  addbi(6);
 until (i=plen);
 writeln(toe,'   '+db+' 255,255,255,0,0,0');
 addbi(6);
 writeln(toe,'');
end;

function findpost:patt;
var zo:patt;
i:integer;
torko:boolean;
cho:patt;
begin
 cho:=nil;
 zo:=plist;
 while zo<>nil do
 begin
  torko:=true;
  for i:=0 to plen-1 do if zo^.d[i].ton<>0 then torko:=false;
  if torko then
  begin
   cho:=zo;
   inc(gg);
  end;
  zo:=zo^.next;
 end;
 result:=cho;
end;

procedure endz;
var i,j,v,nulik:integer;
zo:patt;
begin
 ext:=false;
 if ppos<>0 then
  begin
   for j:=ppos to plen do
   for i:=0 to 15 do
   begin
    tr[i].d[j].ton:=0;
    tr[i].d[j].n:=255;
   end;
   for i:=0 to 15 do uplist[i,posall]:=savepatt(tr[i]);
   inc(posall);
  end;
 zo:=plist;
 v:=0;
 while zo<>nil do
 begin
  inc(v);
  printp(zo);
  zo:=zo^.next;
 end;
  nulik:=(vseby-(counby-(32*curp)))div 32;
  if nulik<posall then posall:=nulik;
 for i:=0 to 15 do
 begin
  uplist[i,posall]:=nil;
  writeln(toe,'ch'+inttostr(i+1)+':');
  for j:=0 to posall-1 do
  writeln(toe,'   '+dw+' fpat'+inttostr(uplist[i,j]^.c)+';'+inttostr(uplist[i,j]^.np));
  writeln(toe,'   '+dw+' 65535');
 end;
 for i:=0 to 15 do dispose(tr[i]);
 writeln(toe,'   ');

 closefile(toe);
end;

function notefreq(n: real): real;
begin
 result:=440*exp(((n-45)/12)*ln(2));
end;

procedure wriz;
var s,sy:string;
i,j,zz:integer;
zo:patt;
begin
 if clot mod dive=sdvig then
 begin
  for i:=0 to 15 do
  begin
   if all[i].n<>255 then
   begin
    zz:=all[i].n+tra+instros[all[i].i].snd[all[i].t].trb;
    if zz<0 then zz:=0;
    if all[i].pau=0 then
    begin
     tr[i]^.d[ppos].ton:=round(12800000/notefreq(zz+(pitch[all[i].k]*polt[all[i].k])));
     tr[i]^.d[ppos].n:=zz;
     tr[i]^.d[ppos].dtb:=all[i].dtb;
    end else
    begin
     tr[i]^.d[ppos].ton:=0;
     tr[i]^.d[ppos].n:=0;
     tr[i]^.d[ppos].dtb:=0;
     dec(all[i].pau);
    end;
    dec(all[i].tmr);
    if all[i].tmr=0 then
    begin
     all[i].n:=255;
     dec(instros[all[i].i].cpf);
    end;
   end
   else
   begin
    tr[i]^.d[ppos].ton:=0;
    tr[i]^.d[ppos].n:=0;
   end;
  end;
  inc(ppos);
  if (ppos=plen) then
  begin
   inc(cby);//if dada=posall then ext:=true;
   ppos:=0;
   if start=0 then
   begin
    for i:=0 to 15 do uplist[i,posall]:=savepatt(tr[i]);
    inc(posall);
   end else dec(start);
  end;
 end;
 inc(clot);
end;



end.
